
workfile monthly m 1977:3 2020:12

'Import data and transform
'----------------------------------------------------
smpl @first @last
read( b3, s=Monthly ) "stockint2013.xls" 10

'Germany
genr GER_RF= log(1+bdinter3(-1)/((100*12)))
genr GER_LTBOND=bdbryld
genr GER_10Y_ytm= log(1+bdbryld/((100*12)))
genr GER_dur= 12*(1-(1+bdbryld*0.01)^(-10))/(1-(1+bdbryld*0.01)^(-1))
genr GER_10Y_hpr=GER_dur(-1)*GER_10Y_ytm(-1)-(GER_dur(-1)-1)*GER_10Y_ytm
genr GER_Bond_ExRet     = GER_10Y_hpr - GER_RF
genr GER_DY=totmkbd_dy_/((100*12))
genr GER_LDY=log(GER_dy)
genr GER_P=totmkbd_pi_
genr GER_LP=log(GER_P)
genr GER_stock_ret=log(GER_P/GER_P(-1)+GER_DY)
genr GER_stock_exret  =GER_stock_ret- GER_RF
genr GER_stock_ret_3Y_E=(GER_P-GER_P(-36))/(GER_P(-36))+ 36*@MOVAV(GER_DY,36)

' -------------- Forex Exchanges ------------------------------------------

genr FX_EUvsUS=euusboe
genr FX_USvsUK=usdollr
genr FX_EUvsUK=FX_EUvsUS*FX_USvsUK
genr FX_r_EUvsUS  = log(FX_EUvsUS/FX_EUvsUS(-1))
genr FX_r_USvsUK  = log(FX_USvsUK/FX_USvsUK(-1))
genr FX_r_EUvsUK  = FX_r_EUvsUS + FX_r_USvsUK

' -------------- US Stocks Monthly Excess Returns -------------------------

genr US_DY=totmkus_dy_/((100*12))
genr US_LDY=log(US_dy)
genr US_P=totmkus_pi_
genr US_LP=log(US_P)
genr US_LP_eu=US_LP+log(euusboe)
genr US_stock_ret=log(US_P/US_P(-1)+US_DY)
genr US_stock_ret_eu=US_stock_ret +FX_r_EUvsUS
genr US_stock_exret  =US_stock_ret_eu- GER_RF
genr US_stock_ret_3Y_E=(US_P-US_P(-36))/(US_P(-36))+ 36*@MOVAV(US_DY,36)+ log(FX_EUvsUS/FX_EUvsUS(-36))

' ------------- UK Stocks Monthly Excess Returns --------------------------
genr UK_DY=totmkuk_dy_/(100*12)
genr UK_LDY=log(UK_dy)
genr UK_P=totmkuk_pi_
genr UK_LP=log(UK_P)
genr UK_LP_eu=UK_LP+log(FX_EUvsUK)
genr UK_stock_ret_e=((UK_P-UK_P(-1))/UK_P(-1))+UK_DY
genr UK_stock_ret=log(UK_P/UK_P(-1)+UK_DY)
genr UK_stock_ret_eu=UK_stock_ret +FX_r_EUvsUK
genr UK_stock_exret  =UK_stock_ret_eu- GER_RF
genr UK_stock_ret_3Y_E=(UK_P-UK_P(-36))/(UK_P(-36))+ 36*@MOVAV(UK_DY,36)+ log(FX_EUvsUK/FX_EUvsUK(-36))

'-------------  Stocks Annual Returns --------------------------
genr UK_stock_ret_eu_1y=UK_stock_ret_eu+UK_stock_ret_eu(-1)+UK_stock_ret_eu(-2)+UK_stock_ret_eu(-3)+UK_stock_ret_eu(-4)+UK_stock_ret_eu(-5)+UK_stock_ret_eu(-6)+UK_stock_ret_eu(-7)+UK_stock_ret_eu(-8)+UK_stock_ret_eu(-9)+UK_stock_ret_eu(-10)+UK_stock_ret_eu(-11)

genr US_stock_ret_eu_1y=US_stock_ret_eu+US_stock_ret_eu(-1)+US_stock_ret_eu(-2)+US_stock_ret_eu(-3)+US_stock_ret_eu(-4)+US_stock_ret_eu(-5)+US_stock_ret_eu(-6)+US_stock_ret_eu(-7)+US_stock_ret_eu(-8)+US_stock_ret_eu(-9)+US_stock_ret_eu(-10)+US_stock_ret_eu(-11)

genr GER_stock_ret_1y=GER_stock_ret+GER_stock_ret(-1)+GER_stock_ret(-2)+GER_stock_ret(-3)+GER_stock_ret(-4)+GER_stock_ret(-5)+GER_stock_ret(-6)+GER_stock_ret(-7)+GER_stock_ret(-8)+GER_stock_ret(-9)+GER_stock_ret(-10)+GER_stock_ret(-11)

genr GER_stock_ret_2y=(GER_stock_ret_1y+GER_stock_ret_1y(-12))
genr UK_stock_ret_eu_2y=(UK_stock_ret_eu_1y+UK_stock_ret_eu_1y(-12))
genr US_stock_ret_eu_2y=(US_stock_ret_eu_1y+US_stock_ret_eu_1y(-12))

genr GER_stock_ret_3y=(GER_stock_ret_1y+GER_stock_ret_1y(-12)+GER_stock_ret_1y(-24))
genr UK_stock_ret_eu_3y=UK_stock_ret_eu_1y+UK_stock_ret_eu_1y(-12)+UK_stock_ret_eu_1y(-24)
genr US_stock_ret_eu_3y=US_stock_ret_eu_1y+US_stock_ret_eu_1y(-12)+US_stock_ret_eu_1y(-24)


 '-------------  Stocks Annual Excess Returns --------------------------

genr UK_stock_exret_1y=UK_stock_exret+UK_stock_exret(-1)+UK_stock_exret(-2)+UK_stock_exret(-3)+UK_stock_exret(-4)+UK_stock_exret(-5)+UK_stock_exret(-6)+UK_stock_exret(-7)+UK_stock_exret(-8)+UK_stock_exret(-9)+UK_stock_exret(-10)+UK_stock_exret(-11)
genr UK_stock_exret_2y=0.5*(UK_stock_exret_1y+UK_stock_exret_1y(-12))
genr UK_stock_exret_3y=(1/3)*(UK_stock_exret_1y+UK_stock_exret_1y(-12)+UK_stock_exret_1y(-24))

genr US_stock_exret_1y=US_stock_exret+US_stock_exret(-1)+US_stock_exret(-2)+US_stock_exret(-3)+US_stock_exret(-4)+US_stock_exret(-5)+US_stock_exret(-6)+US_stock_exret(-7)+US_stock_exret(-8)+US_stock_exret(-9)+US_stock_exret(-10)+US_stock_exret(-11)
genr US_stock_exret_2y=0.5*(US_stock_exret_1y+US_stock_exret_1y(-12))
genr US_stock_exret_3y=(1/3)*(US_stock_exret_1y+US_stock_exret_1y(-12)+US_stock_exret_1y(-24))

genr GER_stock_exret_1y=GER_stock_exret+GER_stock_exret(-1)+GER_stock_exret(-2)+GER_stock_exret(-3)+GER_stock_exret(-4)+GER_stock_exret(-5)+GER_stock_exret(-6)+GER_stock_exret(-7)+GER_stock_exret(-8)+GER_stock_exret(-9)+GER_stock_exret(-10)+GER_stock_exret(-11)
genr GER_stock_exret_2y=0.5*(GER_stock_exret_1y+GER_stock_exret_1y(-12))
genr GER_stock_exret_3y=(1/3)*(GER_stock_exret_1y+GER_stock_exret_1y(-12)+GER_stock_exret_1y(-24))

'----------------------------------------------------------------------------
'SECTION 1: Simulated and Actual Time-Series ARMA 
'----------------------------------------------------------------------------
include "section1.prg"
'---------------------------------------------------------------------------
'SECTION 2: Persistence: A Monte Carlo Experiment
'---------------------------------------------------------------------------
include "section2.prg"

